
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

char buf_cpu[0x100];
char buf_gfx[0x100];
char buf_spr[0x100];
char buf_idle[0x100];

void usage(void)
{
    printf(
        "usage: victimer <args>\n"
        "-b --badline                   show timing in a badline\n"
        "-s <value> --sprites <value>   enable sprites, value as in $d015\n"
    );
    exit(-1);
}

int main(int argc,char **argv)
{
int i;

int cycle,hcycle;
int badline=0;
int cpufree=0;
int cpuwrite=0;
int sprdma=0;
int victaken=0;
int vicidle;
int sprenable=0;
int allcycles=0;

	for(i=1;i<argc;i++)
	{
		if(!strcmp(argv[i],"-b") || !strcmp(argv[i],"--badline"))
		{
			badline=1;
		}
		else if(!strcmp(argv[i],"-s") || !strcmp(argv[i],"--sprites"))
		{
			i++;
			sprenable=strtol(argv[i],NULL,0);
		}
		else
                {
                    usage();
                }
	}

	memset(buf_cpu,0x20,65*2-2);
	memset(buf_gfx,0x20,65*2-2);
	memset(buf_spr,0x20,65*2-2);
	memset(buf_idle,0x20,65*2-2);

	for(hcycle=0;hcycle<(64*2);hcycle++)
	{
		cycle=hcycle/2;
		vicidle=1;

		// CPU
		if(hcycle&1)
		{
			// CPU cycle
			switch(hcycle)
			{
				case  1:

					if(sprenable&(1<<4))
					{
						buf_cpu[hcycle]='W';
						if(cycle>0)cpuwrite++;
					}
					else
					{
						buf_cpu[hcycle]='x';
						if(cycle>0)cpufree++;
					}
					break;
				case  3:
					if(sprenable&(1<<3))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<4))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case  5:
					if(sprenable&(1<<3))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<4))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if(sprenable&(1<<5))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case  7:
					if(sprenable&(1<<4))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<5))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case  9:
					if(sprenable&(1<<4))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if((sprenable&(1<<5)))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if((sprenable&(1<<6)))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 11:
					if(sprenable&(1<<5))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<6))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 13:
					if(sprenable&(1<<5))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if((sprenable&(1<<6)))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if((sprenable&(1<<7)))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 15:
					if(sprenable&(1<<6))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<7))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 17:
					if(sprenable&(1<<6))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<7))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 19:
				case 21:
					if(sprenable&(1<<7))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						buf_cpu[hcycle]='x';
						if(cycle>0)cpufree++;
					}
					break;
				case 25:
				case 27:
				case 29:
					if(badline)
					{
						buf_cpu[hcycle]='W';
						if(cycle>0)cpuwrite++;
					}
					else
					{
						buf_cpu[hcycle]='x';
						if(cycle>0)cpufree++;
					}
					break;

				
				case 111:
				case 113:
					if(sprenable&(1<<0))
					{
						buf_cpu[hcycle]='W';
						if(cycle>0)cpuwrite++;
					}
					else
					{
						buf_cpu[hcycle]='x';
						if(cycle>0)cpufree++;
					}
					break;
				case 115:
					if(sprenable&(1<<0))
					{
						buf_cpu[hcycle]='w';
						if(cycle>0)sprdma++;
					}
					else
					{
						if(sprenable&(1<<1))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
					
				case 117:
					if(sprenable&(1<<0))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<1))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 119:
					if(sprenable&(1<<0))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if((sprenable&(1<<1)))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if((sprenable&(1<<2)))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;

				case 121:
					if(sprenable&(1<<1))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<2))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 123:
					if(sprenable&(1<<1))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if((sprenable&(1<<2)))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if((sprenable&(1<<3)))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 125:
					if(sprenable&(1<<2))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if(sprenable&(1<<3))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				case 127:
					if(sprenable&(1<<2))
					{
						buf_spr[hcycle]='s';
						if(cycle>0)victaken++;
					}
					else
					{
						if((sprenable&(1<<3)))
						{
							buf_cpu[hcycle]='w';
							if(cycle>0)sprdma++;
						}
						else if((sprenable&(1<<4)))
						{
							buf_cpu[hcycle]='W';
							if(cycle>0)cpuwrite++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					break;
				default:
					if(badline)
					{
						if((cycle>14)&&(cycle<55))
						{
							buf_gfx[hcycle]='c';
							if(cycle>0)victaken++;
						}
						else
						{
							buf_cpu[hcycle]='x';
							if(cycle>0)cpufree++;
						}
					}
					else
					{
						buf_cpu[hcycle]='x';
						if(cycle>0)cpufree++;
					}
					break;
			}


		}
		else
		{
			// VIC cycle
			switch(hcycle)
			{
				case  2:
					buf_spr[hcycle]='3';
					break;
				case  4:
					if(sprenable&(1<<3))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case  6:
					buf_spr[hcycle]='4';
					break;
				case  8:
					if(sprenable&(1<<4))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 10:
					buf_spr[hcycle]='5';
					break;
				case 12:
					if(sprenable&(1<<5))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 14:
					buf_spr[hcycle]='6';
					break;
				case 16:
					if(sprenable&(1<<6))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 18:
					buf_spr[hcycle]='7';
					break;
				case 20:
					if(sprenable&(1<<7))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 22 ... 30:
					buf_gfx[hcycle]='r';
					break;
				case 32 ... 110:
					buf_gfx[hcycle]='g';
					break;
				case 112:
				case 114:
					buf_idle[hcycle]='i';
					break;
				case 116:
					buf_spr[hcycle]='0';
					break;
				case 118:
					if(sprenable&(1<<0))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 120:
					buf_spr[hcycle]='1';
					break;
				case 122:
					if(sprenable&(1<<1))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
				case 124:
					buf_spr[hcycle]='2';
					break;
				case 0:
				case 126:
					if(sprenable&(1<<2))
					{
						buf_spr[hcycle]='s';
					}
					else
					{
						buf_idle[hcycle]='i';
					}
					break;
					
			}
			
		}
		
	}

	printf("  |                  1 1 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3 4 4 4 4 4 4 4 4 4 4 5 5 5 5 5 5 5 5 5 5 6 6 6 6 |\n");
	printf("0 |1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 |\n");
	printf("  |                   |===========01020304050607080910111213141516171819202122232425262728293031323334353637383940===========|   |\n");
	printf("--|------------------------------------------------------------------------------------------------------------------------------|\n");
	printf("%c%c|%s|\n",buf_cpu[126],buf_cpu[127],&buf_cpu[2]);
	printf("%c%c|%s|\n",buf_gfx[126],buf_gfx[127],&buf_gfx[2]);
	printf("%c%c|%s|\n",buf_spr[126],buf_spr[127],&buf_spr[2]);
	printf("%c%c|%s|\n",buf_idle[126],buf_idle[127],&buf_idle[2]);
	printf("--|------------------------------------------------------------------------------------------------------------------------------|\n");
	printf("  |                                ^(close sideborder)                                                           ^(open sideborder)\n");
	printf("  |                           ^---FLI----------------->                                                      ^-----^(double line)  \n");
	printf("  |                             ^---DMA Delay--------------------------------------------------------------^                       \n");
	printf("\n");

	if(badline) printf(" badline ");
	if(sprenable) printf(" sprenable=%02x ",sprenable);
	if(badline||sprenable)printf("\n");
	
	printf("CPU: %2d",cpufree);
	if(cpuwrite) printf(" (+%2d=%2d) ",cpuwrite,cpuwrite+cpufree);
	printf("\n");
	
	printf("VIC: %2d",victaken);
	if(sprdma) printf(" (+%2d=%2d)",sprdma,sprdma+victaken);
	printf("\n");

	// sanity check
	allcycles=sprdma+victaken+cpuwrite+cpufree;
	printf("     %2d\n",allcycles);
	
	printf("\n");
	printf("x    - CPU regular cycles\n");
	printf("W    - CPU write cycles\n");
	printf("w    - CPU 3rd write cycle\n");
	printf("c    - VIC video ram\n");
	printf("g    - VIC color ram\n");
	printf("0..7 - VIC sprite pointer fetches\n");
	printf("s    - VIC sprite data accesses\n");
	printf("i    - VIC idle accesses\n");

	return 0;
}
